#!/bin/bash -x
HOME_DIR=`pwd`
DATASET=${1:-dna}
N_ITER=100000
BUFFER_SIZE=30
BATCH_SIZE=24
RUN_DIR="saved_models_bsf13000/${DATASET}"
PATH_DATASET_ALL_CSV=$HOME_DIR/imageData/csvs/${DATASET}.csv
PATH_DATASET_TRAIN_CSV=$HOME_DIR/imageData/csvs/${DATASET}/train.csv
GPU_IDS=${2:-0}

cd $(cd "$(dirname ${BASH_SOURCE})" && pwd)/..

python train_model.py \
       --n_iter ${N_ITER} \
       --path_dataset_csv ${PATH_DATASET_TRAIN_CSV} \
       --buffer_size ${BUFFER_SIZE} \
       --buffer_switch_frequency 13000 \
       --batch_size ${BATCH_SIZE} \
       --path_run_dir ${RUN_DIR} \
       --gpu_ids ${GPU_IDS}
