HOME_DIR=`pwd`
dir_new=${HOME_DIR}/Unet/retrain
dir_old=${HOME_DIR}/Unet/original


# create csv files for retraining all organelles, comment that out if already done
bash Unet/retrain/write_csv_train_new.sh 

# copy the prediction results from original training, copy the original model
cp ${dir_old}/results/3d ${dir_new}/results/3d -r
cp ${dir_old}/saved_models_bsf13000 ${dir_new}/saved_models_bsf13000 -r

# activate conda environment
conda activate fnet

###### start retraining process
cd "${dir_new}" || exit
mkdir saved_models_greedy
mkdir results_greedy

# retrain
model=zo1 # choose your organelle model for retraining
iteration=112500 # set the total iteration numbers, it should be iteration_original + iteration_retrain
param=1.0 # set the parameter, you can run multiple parameters in parallel
PARAM_IDX=0 # This is used for parallel running for multiple parameters

mkdir -p saved_models_greedy/$PARAM_IDX
cp ${dir_new}/saved_models_bsf13000/${model} ${dir_new}/saved_models_greedy/$PARAM_IDX/${model} -r

time bash ./scripts/my_train_greedy.sh ${model} ${iteration} ${param}

# update the predictions
time bash ./scripts/predict_eval_greedy.sh ${model} $PARAM_IDX 0

# create csv files for evaluations
bash write_csv_evaluate_greedy ${model} ${PARAM_IDX}

# timely evaluate on training set
TRAIN_OR_TEST=train
time python evaluate_greedy.py $TRAIN_OR_TEST ${model} $PARAM_IDX ${dir_new}

# update the predictions on both training and test set with the optimal parameter
OPT_PARAM_IDX=$PARAM_IDX
time bash ./scripts/predict_optimal_param.sh ${model} $OPT_PARAM_IDX 0


# evaluate on the test set with the optimal parameter
TRAIN_OR_TEST=test
time python evaluate_greedy.py $TRAIN_OR_TEST ${model} $OPT_PARAM_IDX $HOME_DIR

#One can iteratively do the above steps for all models

cd "${HOME_DIR}" || exit
