#!/bin/bash -x

DATASET=${1:-dna}
N_ITER=${2:-12500}
p=${3:-0.2}
index=${4:-0}
BUFFER_SIZE=30
BATCH_SIZE=24
dir_new=`pwd` #your home directory
RUN_DIR=${dir_new}/saved_models_greedy/${index}/${DATASET}
PATH_DATASET_TRAIN_CSV=${dir_new}/csv/${DATASET}/train/${DATASET}_train.csv
GPU_IDS=${5:-0}
python train_model.py \
       --p ${p} \
       --n_iter ${N_ITER} \
       --class_dataset TiffDataset  \
       --path_dataset_csv ${PATH_DATASET_TRAIN_CSV} \
       --buffer_size ${BUFFER_SIZE} \
       --buffer_switch_frequency 5000 \
       --batch_size ${BATCH_SIZE} \
       --path_run_dir ${RUN_DIR} \
       --gpu_ids ${GPU_IDS}
