#!/bin/bash -x

MODEL=${1}
param_idx=${2}
dir_new=`pwd`
MODEL_DIR=${dir_new}/saved_models_greedy/${param_idx}/${MODEL}
GPU_IDS=${3:-0}
N_IMAGES=60
for DATASET in alpha_tubulin beta_actin desmoplakin dna fibrillarin lamin_b1 membrane_caax_63x myosin_iib sec61_beta st6gal1 tom20 zo1
do 	
	for TEST_OR_TRAIN in train test
	do		
		SAVE_DIR=/${dir_new}/results/3d/${DATASET}/${TEST_OR_TRAIN}/${MODEL}
		CSV_DIR=${dir_new}/csv/${DATASET}/${TEST_OR_TRAIN}/${DATASET}_${TEST_OR_TRAIN}.csv 	
		python predict.py \
	   	--class_dataset TiffDataset \
		--path_model_dir ${MODEL_DIR} \
	   	--path_dataset_csv ${CSV_DIR}\
	   	--n_images ${N_IMAGES} \
		--no_signal \
		--no_target \
		--no_prediction_unpropped \
		--path_save_dir ${SAVE_DIR} \
		--gpu_ids ${GPU_IDS} 
	done
done


